﻿Public Class FCalendario

    Dim Dias() As String = {"Sabado", "Domingo", "Lunes", "Martes", "Miéricoles", "Jueves", "Viernes"}
    Dim FechaReferencia As Integer = 20000101 ' El 01/01/2000 es Sabado. Fecha devuelta por comparación

    Private Function EsBisiesto(ByVal SigloAno As Integer) As Byte ' 0 = No Bisiesto, 1 = Bisiesto
        Dim SS As Integer ' Siglo
        Dim AA As Integer ' Ano
        SS = SigloAno \ 100
        AA = SigloAno - SS * 100
        If ((AA > 0 And AA Mod 4 = 0) Or (AA = 0 And SS Mod 4 = 0)) Then
            Return 1
        End If
        Return 0
    End Function

    Private Function NumeroDiasHastaFinesMese(ByVal SigloAno As Integer, ByVal Mese As Integer) As Integer
        Select Case Mese
            Case 1, 3, 5, 7, 8, 10, 12
                Return 31
            Case 2
                Return (28 + EsBisiesto(SigloAno))
            Case Else
                Return 30
        End Select
    End Function

    Private Function ACuantos(ByVal FechaDevuelta As Integer) As Integer
        Dim SSAA As Integer ' Siglo con Ano
        Dim MM As Integer ' Mese
        Dim DD As Integer ' Dia
        Dim DDD As Integer ' A cuantos
        SSAA = FechaDevuelta / 10000
        MM = FechaDevuelta / 100 - SSAA * 100
        DD = FechaDevuelta - (SSAA * 10000 + MM * 100)
        DDD = DD
        For i As Integer = 1 To MM - 1
            DDD = DDD + NumeroDiasHastaFinesMese(SSAA, i)
        Next i    
        Return DDD
    End Function

    Private Function NumeroDiasHastaFinesAno(ByVal FechaDevuelta As Integer) As Integer
        Dim SSAA As Integer
        Dim FechaFines As Integer
        SSAA = FechaDevuelta \ 10000
        FechaFines = SSAA * 10000 + 1231
        Return ACuantos(FechaFines) - ACuantos(FechaDevuelta)
    End Function

    Private Function NumeroDiasDesdeInicioAno(ByVal FechaDevuelta As Integer) As Integer
        Dim SSAA As Integer
        Dim FechaInicia As Integer
        SSAA = FechaDevuelta \ 10000
        FechaInicia = SSAA * 10000 + 101
        Return ACuantos(FechaDevuelta) - ACuantos(FechaInicia)
    End Function

    Private Function NumeroDiasEntreFechas(ByVal FechaDevuelta1 As Integer, ByVal FechaDevuelta2 As Integer) As Integer
        Dim Tmp As Integer
        Dim SSAAInicia As Integer
        Dim SSAAFines As Integer
        Dim NumeroDias As Integer
        If FechaDevuelta1 > FechaDevuelta2 Then
            Tmp = FechaDevuelta1
            FechaDevuelta1 = FechaDevuelta2
            FechaDevuelta2 = Tmp
        End If
        SSAAInicia = FechaDevuelta1 \ 10000
        SSAAFines = FechaDevuelta2 \ 10000
        If SSAAInicia = SSAAFines Then
            Return ACuantos(FechaDevuelta2) - ACuantos(FechaDevuelta1)
        End If
        NumeroDias = NumeroDiasHastaFinesAno(FechaDevuelta1) + NumeroDiasDesdeInicioAno(FechaDevuelta2) + 1
        For Tmp = SSAAInicia + 1 To SSAAFines - 1
            NumeroDias = NumeroDias + 365 + EsBisiesto(Tmp)
        Next Tmp
        Return NumeroDias
    End Function

    Private Function DevolverFecha(ByVal Fecha As String) As Integer
        Dim ValorFecha As Integer
        Dim IDeb As Integer ' Indice del inicio
        Dim IFin As Integer ' Indice del fines
        ValorFecha = CType(Fecha.Substring(Fecha.Length - 4), Long) * 10000  ' AAAA0000 
        IDeb = Fecha.IndexOf("/") ' Indice del primer / ............  D o DD / M o MM / AAAA
        IFin = Fecha.LastIndexOf("/") ' Indice del ultimor / ............  D o DD / M o MM / AAAA
        ValorFecha = ValorFecha + CType(Fecha.Substring(IDeb + 1, IFin - IDeb - 1), Long) * 100 ' AAAAMM00
        ValorFecha = ValorFecha + CType(Fecha.Substring(0, IDeb), Long) ' AAAAMMD ou AAAAMMDD
        Return ValorFecha
    End Function

    Private Function IndiceDelDia(ByVal Fecha As String) As Integer ' -1 si error
        Dim X As Integer
        Dim NumeroDias As Integer
        Dim FechaActual As Integer
        Try
            Fecha = Fecha.Replace("-", "/")
            FechaActual = DevolverFecha(Fecha)
            NumeroDias = NumeroDiasEntreFechas(FechaReferencia, FechaActual)
            X = NumeroDias Mod 7
            If FechaActual < FechaReferencia Then
                If X > 0 Then
                    X = 7 - X
                End If
            End If
        Catch
            Return -1
        End Try
        Return X
    End Function

    ' ***************  Probar  ********************
    Private Sub BProbar_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Probar.Click
        Dim NombreDelDia As String
        Dim Indice As String
        If Not TextBox1.Text = String.Empty Then
            Indice = IndiceDelDia(TextBox1.Text)
            If Indice > -1 Then
                NombreDelDia = Dias(Indice)
                MessageBox.Show(NombreDelDia)
            End If
        End If
    End Sub

End Class

